import sys, sorting, random, time
from ordinamento import *

def misuraTempo(procedura, lista):
  t1 = time.clock()
  procedura(lista)
  t2 = time.clock()
  return t2 - t1

def provaTuttiSuStessaLista(algoritmiOrdinamento, listaOrigine):
  n = len(listaOrigine)
  print("lista di ", n, " elementi\n")
  file.write("lista di " + str(n) + " elementi\n\n")
  for algor in algoritmiOrdinamento:
    lista = listaOrigine[:]
    print(str(algor) + " su lista di interi")
    file.write(str(algor) + " su lista di interi\n")
    if èOrdinata(lista): print("la lista e' gia' ordinata!")
    else: print("la lista non e' ordinata")
    print('sto ordinando ...')
    t = misuraTempo(algor, lista)
    if not èOrdinata(lista):
      print("ERRORE! La lista NON e' stata ordinata!!")
      file.write("ERRORE! La lista NON e' stata ordinata!!\n")
    print('tempo impiegato = {0:.2f} s.\n'.format(t))
    file.write('tempo impiegato = {0:.2f} s.\n\n'.format(t))

  print("\n**********************************************\n")
  file.write("\n**********************************************\n\n")


MAX_VAL = 100000 # valore massimo
N =2500
algoritmi = [qsort, isort, ssort]

file = open("tempi.txt", 'w')
for k in range(1,6):
  n = k*N
  listaCasuale = [random.randint(0, MAX_VAL) for i in range(n)]
  provaTuttiSuStessaLista(algoritmi, listaCasuale)
  qsort(listaCasuale)
  scambia(listaCasuale, 100, 800)
  scambia(listaCasuale, 400, 600)
  print("provo gli algoritmi su una LISTA QUASI ORDINATA\n")
  file.write("provo gli algoritmi su una LISTA QUASI ORDINATA\n")
  provaTuttiSuStessaLista(algoritmi, listaCasuale)
file.close()






